import { take } from './generators';
function makeDescription(description, arg) {
    if (typeof description === 'function')
        return description(arg);
    return `${description} - with input ${JSON.stringify(arg, null, 2)}`;
}
/**
 * Examples: {@link ./fuzz.examples.test.ts}
 * @param iterable
 * @param description
 * @param fn
 * @param samples
 */
export function fuzz(iterable, description, fn, samples = 7) {
    for (const item of take(iterable, samples)()) {
        // eslint-disable-next-line prefer-arrow-callback,func-names
        test(makeDescription(description, item), async function () {
            await fn.call(this, item);
        });
    }
}
/**
 * Examples: {@link ./fuzz.examples.test.ts}
 * @param iterable
 * @param description
 * @param fn
 * @param samples
 */
export function fuzzDescribe(iterable, description, fn, samples = 7) {
    for (const item of take(iterable, samples)()) {
        // eslint-disable-next-line prefer-arrow-callback,func-names
        describe(makeDescription(description, item), function () {
            fn.call(this, item);
        });
    }
}
//# sourceMappingURL=fuzz.js.map